<?php
/**
 * User: nester_a
 * Date: 29.10.13
 */

namespace LMS\Tools\Conference\Repositories;

use LMS\Tools\Conference\Table;
use LMS\Libraries\Base;
use LMS\Libraries\Date;

class Oauth extends Base\Repository
{
	/**
	 * @var Date\Handler
	 */
	private $dateHandler;

    public function __construct($options)
    {
        parent::__construct($options);
		$this->table = new Table\Oauth();
		$this->dateHandler = new Date\Handler();
    }

	/**
	 * @return mixed
	 */
	public function getUserOAuthData($userID)
	{
		$query = "SELECT *
                    FROM
                        #__lms_conference_oauth WHERE user_id = ".$userID;
		$this->db->setQuery($query);
		return $this->db->loadObject();
	}

    /**
     * @return mixed
     */
    public function getCommonOAuthData()
    {
        $query = "SELECT *
                    FROM
                        #__lms_conference_oauth WHERE user_id = 0";
        $this->db->setQuery($query);
        return $this->db->loadObject();
    }

	protected function beforeSave(&$data)
	{
		$data['token'] = $data['access_token'];
		$data['created'] = $this->dateHandler->getCurrentUTCDatetime();
	}

}