<?php
defined( '_JLMS_EXEC' ) or die( 'Restricted access' );

class JLMS_sprypay{
	function show_checkout( $option, $subscription, $item_id, $proc ) {
		global $mainframe, $mosConfig_live_site, $Itemid, $JLMS_CONFIG;
		
		$mainframe = & JFactory::getApplication();
		
		$params = new JLMSParameters( $proc->params );
		
		$params->set('server_url', 'https://sprypay.ru/sppi/');
		
		if (!$params->get( 'shop_id' ) || !$params->get( 'shop_key' )) {
			$redirect_task = 'subscription';
			if ($subscription->payment_type == 2) {
				$redirect_task = 'show_cart';
			}
			JLMSredirect(sefRelToAbs("index.php?option=".$option."&Itemid=".$Itemid."&task=$redirect_task"), "This payment method is not available at the moment.<br /> Ask site administrator to check payment method settings.");
		}
		setcookie('joomlalms_cart_contents', '', time()-3600, '/');
		
		global $JLMS_DB;
		if ($subscription->payment_type) {
			$sub_id = $subscription->id;
			$query = "SELECT course_id FROM #__lms_subscriptions_courses WHERE sub_id = $sub_id";
			$JLMS_DB->SetQuery($query);
			$courses = $JLMS_DB->LoadResultArray();
		} else {
			$courses = array();
		}
		
		$query = "SELECT email FROM #__users WHERE id = '".$subscription->user_id."'";
		$JLMS_DB->SetQuery($query);
		$user_email = $JLMS_DB->loadResult();
		
		$lang = 'en';
		$default_language = $JLMS_CONFIG->get('default_language');
		if($default_language == 'english'){
			$lang = 'en';
		} else 
		if($default_language != 'english'){
			$lang = 'ru';
		}
		
		$ipn_url = $mainframe->getCfg('live_site').'/index.php?option=com_joomla_lms&task=callback&trs_id='.$item_id.'&proc='.$proc->id;
		$return_url = $mainframe->getCfg('live_site').'/index.php?option=com_joomla_lms&Itemid='.$Itemid;
		?>
		<html>
		<body onLoad="document.forms.jlms_checkout_form.submit();">
		
		<form action="<?php echo $params->get( 'server_url' );?>" method="post" name="jlms_checkout_form" id="jlms_checkout_form" />
		<input type="hidden" name="spShopId" value="<?php echo $params->get('shop_id');?>" />
		<input type="hidden" name="spShopPaymentId" value="<?php echo $item_id;?>" />
		<input type="hidden" name="spAmount" value="<?php echo number_format($subscription->price + $subscription->tax_amount, 2, '.', '');?>" />
		<input type="hidden" name="spCurrency" value="<?php echo strtolower($JLMS_CONFIG->get('jlms_cur_code'));?>" />
		<input type="hidden" name="spPurpose" value="<?php echo ($params->get( 'item_name') == '[sub]' && $subscription->sub_name) ? $subscription->sub_name : $params->get( 'item_name');?>" />
		
		<input type="hidden" name="spUserEmail" value="<?php echo $user_email;?>" />
		
		<input type="hidden" name="spIpnUrl" value="<?php echo $ipn_url;?>" />
		<input type="hidden" name="spIpnMethod" value="1" />
		
		<input type="hidden" name="spSuccessUrl" value="<?php echo $return_url;?>" />
		<input type="hidden" name="spSuccessMethod" value="1" />
		
		<input type="hidden" name="spFailUrl" value="<?php echo $return_url;?>" />
		<input type="hidden" name="spFailMethod" value="1" />
		
		<input type="hidden" name="lang" value="<?php echo $lang;?>" />
		<?php if($params->get('tab_num')){?>
		<input type="hidden" name="tabNum" value="<?php echo $params->get('tab_num');?>" />
		<?php }?>
		
		</form>
		</body>
		</html>
		<?php
		die();
	}
	
	function show_billing_form($option, $proc, $user){
		//no billing details
	}
	
	function validate_callback($proc){
		global $mosConfig_live_site, $Itemid, $JLMS_CONFIG, $JLMS_DB;
		
		$params = new JLMSParameters( $proc->params );
		
		$spPaymentId 				= $_POST['spPaymentId'];
		$spShopId 					= $_POST['spShopId'];
		$spShopPaymentId 			= $_POST['spShopPaymentId'];
		$spBalanceAmount			= $_POST['spBalanceAmount'];
		$spAmount					= $_POST['spAmount'];
		$spCurrency					= $_POST['spCurrency'];
		$spCustomerEmail			= $_POST['spCustomerEmail'];
		$spPurpose					= $_POST['spPurpose'];
		$spPaymentSystemId			= $_POST['spPaymentSystemId'];
		$spPaymentSystemAmount 		= $_POST['spPaymentSystemAmount'];
		$spPaymentSystemPaymentId 	= $_POST['spPaymentSystemPaymentId'];
		$spEnrollDateTime 			= $_POST['spEnrollDateTime'];
		$spHashString 				= $_POST['spHashString'];
		
		if(isset($spPaymentId) && $spPaymentId){
			
			$hashstring = $spPaymentId.$spShopId.$spShopPaymentId.$spBalanceAmount.$spAmount.$spCurrency.$spCustomerEmail.$spPurpose.$spPaymentSystemId.$spPaymentSystemAmount.$spPaymentSystemPaymentId.$spEnrollDateTime;
			
			$hashstring = $hashstring.$params->get('shop_key');
			$hashstring_ = $hashstring;
			$hashstring = md5($hashstring_);
					
			if($hashstring == $spHashString){
				if(strtoupper($JLMS_CONFIG->get('jlms_cur_code')) == strtoupper($spCurrency)){
					if(intval($params->get('shop_id')) == intval($spShopId)){
						require_once(_JOOMLMS_FRONT_HOME.'/includes/joomla_lms.subscription.lib.php');
						if(jlms_check_payment_transaction($spAmount, $spShopPaymentId)){
							echo "ok";
							$query = "SELECT status FROM `#__lms_payments` WHERE id = '".$spShopPaymentId."'";
							$JLMS_DB->setQuery($query);
							$prev_payment = $JLMS_DB->LoadResult();
							jlms_update_payment( $spShopPaymentId, $spPaymentId, 'Completed', gmdate("Y-m-d H:i:s") );
							if ($prev_payment == 'Completed'){
							} else {
								jlms_register_new_user($spShopPaymentId);
							}
						}
					}
				}
			}
			die;
		} else {
			if($status){
				jlms_update_payment( $spShopPaymentId, $spPaymentId, 'Pending', gmdate("Y-m-d H:i:s") );
			}
			JLMSRedirect(sefRelToAbs("index.php?option=com_joomla_lms&Itemid=$Itemid"));
		}
	}
}
?>