<?php
namespace LMS\Tools\Subscriptions\Model;

use LMS\Libraries;
use LMS\Libraries\Base;

defined('_JEXEC') or die;

class Subscriptions extends Base\Model
{
	protected $name = 'Subscriptions';
	
	protected $modelDir = __DIR__;

	public function __construct($options)
	{
		Libraries\ServiceLocator::load('tool.subscriptions');
			
		$this->repository = Libraries\ServiceLocator::get('subscription_rep');		
		
		parent::__construct($options);		
		
		$this->setState('fields', 'subscription.id, subscription.account_type, subscription.title, subscription.start_date, subscription.end_date, subscription.access_days, subscription.discount, subscription.price');		
	}	
}